<template>
    <div>
        <v-navigation-drawer v-model="drawer" app fixed :dark="darkTheme" :width="menuWidth" :color="sideBackColor">
            <v-toolbar :color="logoBackColor" :dark="darkTheme" :prominent="prominentLogo">
                <v-img :src="mainLogo" contain style="height: inherit;"/>
            </v-toolbar>
            <perfect-scrollbar>
                <v-list dense expand class="mt-12" :dark="darkTheme" shaped>
                    <template v-for="(item,i) in menus">
                        <v-list-group v-if="item.items" :key="item.name" :prepend-icon="item.icon"
                                      :active-class="darkTheme?'white--text':''">
                            <template v-slot:activator>
                                <v-list-item-title>
                                    {{ item.title }}
                                </v-list-item-title>
                            </template>
                            <template v-for="(subItem,i) in item.items">
                                <!-- Sub Group -->
                                <v-list-group sub-group no-action :group="subItem.group" :key="subItem.name"
                                              v-if="subItem.items" :active-class="darkTheme?'white--text':''">
                                    <template v-slot:activator>
                                        <v-list-item-title>
                                            {{ subItem.title }}
                                        </v-list-item-title>
                                    </template>
                                    <v-list-item :href="grand.href" :key="i"
                                                 :to="genChildTarget(item, grand)"
                                                 v-for="(grand, i) in subItem.items">
                                        <v-list-item-content>
                                            <v-list-item-title>{{ grand.title }}</v-list-item-title>
                                        </v-list-item-content>
                                    </v-list-item>
                                </v-list-group>
                                <v-list-item :disabled="subItem.disabled" :key="i" :to="genChildTarget(item,subItem)"
                                             :active-class="darkTheme?'white--text':''">
                                    <v-list-item-icon>
                                        <v-icon>mdi-chevron-right</v-icon>
                                        <v-list-item-title>{{ subItem.title }}</v-list-item-title>
                                        <v-list-item-action>
                                            <v-icon :class="[subItem.actionClass || 'success--text']">
                                                {{ subItem.action }}
                                            </v-icon>
                                        </v-list-item-action>
                                    </v-list-item-icon>
                                </v-list-item>
                            </template>
                        </v-list-group>
                        <v-subheader :key="i" v-else-if="item.header">{{ item.header }}</v-subheader>
                        <v-divider :key="i" v-else-if="item.divider"/>
                        <!-- Top Level-->
                        <v-list-item :disabled="item.disabled" :href="item.href" :key="item.name"
                                     :target="item.target" :to="!item.href ? { name: item.name } : null" v-else>
                            <v-list-item-icon v-if="item.icon">
                                <v-icon>{{ item.icon }}</v-icon>
                            </v-list-item-icon>
                            <v-list-item-title>{{ item.title }}</v-list-item-title>
                        </v-list-item>
                    </template>
                </v-list>
            </perfect-scrollbar>
        </v-navigation-drawer>
        <v-app-bar app :dark="appBarDark" :color="appBarColor">
            <v-btn icon color="accent" @click.stop="drawer = !drawer">
                <v-icon>{{ drawer ? 'mdi-chevron-double-left':'mdi-chevron-double-right' }}</v-icon>
            </v-btn>
            <v-toolbar-title
                    style="width: 300px"
                    class="ml-0 pl-4">
                <span class="hidden-sm-and-down">Ingenieria en Siniestros Alcázar</span>
            </v-toolbar-title>
            <v-spacer/>
            <v-menu v-model="menu" :close-on-content-click="false" :nudge-width="200" offset-y>
                <template v-slot:activator="{ on }">
                    <v-btn fab small color="accent" class="elevation-2" dark v-on="on">
                      <img rounded src="https://randomuser.me/portraits/thumb/men/10.jpg" alt="Mariana">
                    </v-btn>
                </template>
                <v-card>
                    <v-toolbar dark height="100%">
                        <v-list dense>
                            <v-list-item>
                                <v-list-item-avatar>
                                    <img src="https://randomuser.me/portraits/thumb/men/10.jpg" alt="Mariana">
                                </v-list-item-avatar>
                                <v-list-item-content>
                                    <v-list-item-title>Juan perez</v-list-item-title>
                                    <v-list-item-subtitle>Administrador</v-list-item-subtitle>
                                </v-list-item-content>
                            </v-list-item>
                        </v-list>
                    </v-toolbar>

                    <v-list>
                        <v-list-item>
                            <v-list-item-icon>
                                <v-icon>mdi-account-settings-outline</v-icon>
                            </v-list-item-icon>
                            <v-list-item-title>Perfil</v-list-item-title>
                        </v-list-item>

                        <v-list-item :to="{name:'login'}">
                            <v-list-item-icon>
                                <v-icon dark color="red">mdi-logout</v-icon>
                            </v-list-item-icon>
                            <v-list-item-title>Cerrar sesión</v-list-item-title>
                        </v-list-item>
                    </v-list>

                </v-card>
            </v-menu>
        </v-app-bar>
        <v-content>
            <div class="page-wrapper">
                <v-toolbar flat color="transparent" dense>
                    <v-toolbar-items>
                            <v-breadcrumbs class="text-uppercase" :items="crumbs" >
                                <template v-slot:divider>
                                    <v-icon>fas fa-angle-double-right</v-icon>
                                </template>
                            </v-breadcrumbs>
                    </v-toolbar-items>
                </v-toolbar>
                <v-fade-transition mode="out-in">
                    <router-view/>
                </v-fade-transition>
            </div>
        </v-content>

    </div>
</template>

<script>
    import menu from '../../utils/menu'

    export default {
        name: 'home',
        components: {},
        computed: {
            version() {
                return process.env.VUE_APP_VERSIONP
            },
            currentYear() {
                return new Date().getFullYear()
            },
            crumbs: function () {
                let pathArray = this.$route.path.split("/")
                pathArray.shift()
                let breadcrumbs = pathArray.reduce((breadcrumbArray, path, idx) => {
                    breadcrumbArray.push({
                        path: path,
                        to: breadcrumbArray[idx - 1]
                            ? "/" + breadcrumbArray[idx - 1].path + "/" + path
                            : "/" + path,
                        text: this.$route.matched[idx].meta.breadCrumb || path,
                    });
                    return breadcrumbArray;
                }, [])
                return breadcrumbs;
            }
        },
        data: () => ({
            drawer: null,
            menus: menu,
            menuWidth: 250, // Ancho de la barra lateral principal
            mainLogo: require('../../assets/branding/logo.png'), // Este es el logo que aparece en la barra lateral
            prominentLogo: true, // Logo pequeño o Grande
            logoBackColor: 'indigo lighten-1', // Color de fondo para el logo de la barra lateral
            sideBackColor: 'indigo lighten-1', // Color de fondo de la barra lateral
            darkTheme: true, // Tema obscuro ( letras en blanco en caso de colores obscuros de la barra lateral)
            appBarColor: '', // Color de la barra principal de la app
            appBarDark: false // Tema obscuro ( letras en blanco en caso de colores obscuros de la barra principal)
        }),
        methods: {
            genChildTarget(item, subItem) {
                if (subItem.href) return;
                if (subItem.component) {
                    return {
                        name: subItem.component,
                    };
                }
                return {name: `${item.group}/${(subItem.name)}`};
            },

        }
    }
</script>
